import java.awt.dnd.*;
import javax.media.j3d.*;
import javax.vecmath.*;

import j3dui.utils.Debug;

/**
A memento added to node objects allowing them to participate
in drag and drop operations.

@author Jon Barrilleaux,
copyright (c) 1999 Jon Barrilleaux,
All Rights Reserved.
*/
public class DndNodeInfo { 
	
	// public interface =========================================
	
	public DndNodeInfo(String name) {
		this(name, DnDConstants.ACTION_COPY_OR_MOVE |
		 DnDConstants.ACTION_LINK);
	}

	public DndNodeInfo(String name, int actions) {
		_name = name;
		_targetActions = actions;
	}

	public String getName() {
		return _name;
	}

	public int getTargetActions() {
		return _targetActions;
	}
			
	// personal body ============================================
	
	private String _name;
	private int _targetActions;

}