import javax.media.j3d.*;
import javax.vecmath.*;

import j3dui.utils.Debug;
import j3dui.utils.*;
import j3dui.utils.app.*;
import j3dui.utils.objects.*;
import j3dui.utils.blocks.*;
import j3dui.control.inputs.*;

/**
An example of a 'fancy' application with Swing data
access components.
<P>
Refer to the book for further details about this example.
<P>
A bug in Java 3D 1.2 causes the pieces of the model to
randomly appear and disappear when modifying the contents of
the scenegraph.  Run this example using Java 3D 1.1. 

@author Jon Barrilleax,
copyright (c) 1999-2000 Jon Barrilleaux,
All Rights Reserved.
*/

public class FancyApp extends FancyFrame {
	
	public static void main(String[] argv) {
		Debug.loadAllProperties();
		new FancyApp();
	}
	
	// public interface =========================================
	
	public FancyApp() {
		setTitle("Example - FancyApp");
		
		new HelpDialog(this, "Help - FancyApp",
		 "An example of an application frame with Swing data " +
		 "access components." +
		 "\n" +
		 "\n" +
		 "> Left-button drag in displays to tilt and turn " +
		 "view." +
		 "\n" +
		 "> Click on tree to expand scene graph nodes." +
		 "\n" +
		 "> Double-click on palette items to add them to " +
		 "scene." +
		 "\n" +
		 "> Use menus to clear scene and print displays." +
		 "\n" +
		 "\n" +
		 ">>> When printing a display, the print preview " +
		 "window pops up behind the main window." +
		 "\n" +
		 ">>> A bug in Java 3D 1.2 causes pieces of the model " +
		 "to randomly appear and disappear.  Run this example " +
		 "using Java 3D 1.1." +
		 "\n" +
		 "\n" +
		 "Refer to the book for further details about this " +
		 "example." +
		 "\n" +
		 "copyright (c) 1999-2000 Jon Barrilleaux, " +
		 "All Rights Reserved."
		);
		
		// setup views
		getWorld().addViewNode(
		 ActuationBlocks.buildViewOrbiter(getViewLeft(),
		 new Vector3d(-Math.PI/8, -Math.PI/8, 0),
		 8, Input.BUTTON_FIRST, Input.MODIFIER_NONE,
		 Input.MODIFIER_NONE)
		);
		getWorld().addViewNode(
		 ActuationBlocks.buildViewOrbiter(getViewRight(),
		 new Vector3d(-Math.PI/8, Math.PI/8, 0),
		 8, Input.BUTTON_FIRST, Input.MODIFIER_NONE,
		 Input.MODIFIER_NONE)
		);		 
		
		// setup scene
		getWorld().addSceneNode(new TestThing());

		// done
		showFrame();
	}
			
	// personal body ============================================

}